Index: branches/PushGP/HeuristicLab.PushGP/TestPooling/Program.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/TestPooling/Program.cs	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/TestPooling/Program.cs	(revision 14745)
@@ -4,9 +4,17 @@
   using System;
   using System.Diagnostics;
+  using System.Threading;
 
   using TestPooling.Pool;
 
   class Program {
-    private const int Count = 3000;
+    private const int PartitionSize = 512;
+    private const int ExampleCount = 200;
+    private const int InstanceCount = 1024;
+    private const int PopulationCount = 100;
+
+    private static int TotalInstanceCount => PopulationCount * InstanceCount * ExampleCount;
+
+
     static void Main(string[] args) {
       Test1();
@@ -19,18 +27,18 @@
 
       sw.Start();
-      //Parallel.For(0, 3, k => {
-      Parallel.For(0, 10000, i => {
-        using (var pool = new ManagedPool<Person>(Count, () => new Person())) {
-          for (var j = 0; j < 3000; j++) {
-            var person = pool.Get();
-            person.Age = i + j;
-            person.Name = string.Format("{0} - {1}", i, j);
+      Parallel.For(0, PopulationCount, pc => {
+        for (var e = 0; e < ExampleCount; e++) {
+          using (var pool = new ManagedPool<Person>(PartitionSize, () => new Person())) {
+            for (var i = 0; i < InstanceCount; i++) {
+              var person = pool.Get();
+              person.Age = pc + e + i;
+              person.Name = string.Format("{0} - {1} - {2}", pc, e, i);
+            }
           }
         }
       });
-      //});
       sw.Stop();
 
-      Console.WriteLine("1 - Duration: {0} - {1}", sw.ElapsedTicks, sw.Elapsed.TotalSeconds);
+      Console.WriteLine("1 - Duration: {0} - {1} for {2}/{3} instances", sw.ElapsedTicks, sw.Elapsed.TotalSeconds, ManagedPool<Person>.InstanceCount, TotalInstanceCount);
     }
 
@@ -39,48 +47,21 @@
       sw.Start();
 
-      var dummyPartition = new Person[Count];
+      var provider = new ManagedPoolProvider<Person>(PartitionSize);
+      provider.InitDummyPartition(() => new Person());
 
-      for (var i = 0; i < Count; i++) {
-        dummyPartition[i] = new Person();
-      }
-
-      //Parallel.For(0, 3, k => {
-      Parallel.For(0, 10000, i => {
-        using (var pool = new ManagedPool2<Person>(Count, dummyPartition, () => new Person())) {
-          for (var j = 0; j < 3000; j++) {
-            var person = pool.Get();
-            person.Age = i + j;
-            person.Name = string.Format("{0} - {1}", i, j);
+      Parallel.For(0, PopulationCount, pc => {
+        for (var e = 0; e < ExampleCount; e++) {
+          using (var pool = provider.CreatePool()) {
+            for (var i = 0; i < InstanceCount; i++) {
+              var person = pool.Get();
+              person.Age = pc + e + i;
+              person.Name = string.Format("{0} - {1} - {2}", pc, e, i);
+            }
           }
         }
       });
-      //});
       sw.Stop();
 
-      //var p1 = new ManagedPool2<Person>(Count, dummyPartition, () => new TestPooling.Person());
-      //var p2 = new ManagedPool2<Person>(Count, dummyPartition, () => new TestPooling.Person());
-      //var pa1 = p1.Get();
-      //var pa2 = p2.Get();
-
-      Console.WriteLine("1_2 - Duration: {0} - {1}", sw.ElapsedTicks, sw.Elapsed.TotalSeconds);
-    }
-
-    private static void Test4() {
-      var sw = new Stopwatch();
-
-      sw.Start(); ;
-      var pool = new ManagedPool<Person>(512, () => new Person());
-
-      Parallel.For(0, 10000, i => {
-        for (var j = 0; j < 3000; j++) {
-          var person = pool.Get();
-          person.Age = i + j;
-          person.Name = string.Format("{0} - {1}", i, j);
-        }
-        pool.Dispose();
-      });
-      sw.Stop();
-
-      Console.WriteLine("1 - Duration: {0}", sw.ElapsedTicks);
+      Console.WriteLine("1_2 - Duration: {0} - {1} for {2}/{3} instances", sw.ElapsedTicks, sw.Elapsed.TotalSeconds, provider.InstanceCount, TotalInstanceCount);
     }
 
@@ -90,17 +71,21 @@
 
       sw.Start();
-      Parallel.For(0, 10000, i => {
-        var list = new Person[3000];
+      Parallel.For(0, PopulationCount, pc => {
+        for (var e = 0; e < ExampleCount; e++) {
+          var list = new Person[InstanceCount];
+          for (var i = 0; i < InstanceCount; i++) {
+            list[i] = new Person {
+              Age = pc + e + i,
+              Name = string.Format("{0} - {1} - {2}", pc, e, i)
+            };
+          }
 
-        for (var j = 0; j < 3000; j++) {
-          list[j] = new Person { Age = i + j, Name = string.Format("{0} - {1}", i, j) };
+          Interlocked.Add(ref count, list.Length);
         }
-
-        count += list.Length;
       });
       sw.Stop();
 
       Console.WriteLine("3 - Duration: {0} - {1}", sw.ElapsedTicks, sw.Elapsed.TotalSeconds);
-      Console.WriteLine("Count: {0}", count);
+      Console.WriteLine("PartitionSize: {0}", count);
     }
 
Index: branches/PushGP/HeuristicLab.PushGP/TestPooling/TestPooling.csproj
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/TestPooling/TestPooling.csproj	(revision 14744)
+++ branches/PushGP/HeuristicLab.PushGP/TestPooling/TestPooling.csproj	(revision 14745)
@@ -44,4 +44,5 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="Pool\IManagedPool.cs" />
     <Compile Include="Pool\ManagedPool.cs" />
     <Compile Include="Pool\ManagedPool2.cs" />
